#pragma rtGlobals=1		// Use modern global access method.



function/S getLicence()
	string licence
	licence = " <!--\n"
	licence += "\n"
	licence += " Author: Charly Rousseau <crousse@nimr.mrc.ac.uk>\n"
	licence += " Copyright (C) 2013 Charly Rousseau <crousse@nimr.mrc.ac.uk>\n"
	licence += " This library is free software; you can redistribute it and/or\n"
	licence += " modify it under the terms of the GNU Library General Public\n"
	licence += " License as published by the Free Software Foundation; either\n"
	licence += " version 2 of the License, or (at your option) any later version.\n"
	licence += "\n"
	licence += " This library is distributed in the hope that it will be useful,\n"
	licence += " but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
	licence += " MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
	licence += " Library General Public License for more details.\n"
	licence += "\n"
	licence += " You should have received a copy of the GNU Library General Public\n"
	licence += " License along with this library; if not, write to the\n"
	licence += " Free Software Foundation, Inc., 59 Temple Place - Suite 330,\n"
	licence += " Boston, MA 02111-1307, USA.\n"
	licence += "\n"
	licence += " -->\n"


	return licence
end

function/S getMetadata()
	string metadata
	metadata = "\t<metadata>\n"
	metadata += "\t  <property name=\"mimetypes\">text/x-gap</property>\n" //  FIXME use variable instead of hard coding gap
	metadata += "\t  <property name=\"globs\">*.ipf</property>\n"
	metadata += "\t  <property name=\"line-comment-start\">//</property>\n"
	metadata += "\t</metadata>\n"
	
	return metadata
end

function/S getStyles() // keyword categories are defined here
	string styles
	styles = "\t<styles>\n"
	styles += "\t  <style id=\"comment\" name=\"Comment\" map-to=\"def:comment\"/>\n"
	styles += "\t  <style id=\"string\" name=\"String\" map-to=\"def:string\"/>\n"
	styles += "\t  <style id=\"character\" name=\"Character\" map-to=\"def:string\"/>\n"
	styles += "\t  <style id=\"keyword\" name=\"Keyword\" map-to=\"def:keyword\"/>\n"
	styles += "\t  <style id=\"type\" name=\"Data type\" map-to=\"def:type\"/>\n"
	styles += "\t  <style id=\"function\" name=\"Function\" map-to=\"def:function\"/>\n"
	styles += "\t  <style id=\"decimal\" name=\"Decimal\" map-to=\"def:decimal\"/>\n"
	styles += "\t</styles>\n"

	return styles
end

function/S getTypes()
	string types = "\t  <context id=\"types\" style-ref=\"type\">\n"
	string myTypesList = typesList() + FlowControlList() // Both have the same color in Igor
	variable nTypes = itemsInList(myTypesList)
	variable i
	for(i=0; i < nTypes; i+=1)
		types += "\t   <keyword>" + stringFromList(i, myTypesList) + "</keyword>\n"
	endFor
	types+= "\t  </context>\n"
	return types
end

function/S getFunctions() // Igor built-in functions
	string functionsList=FunctionList("*", ";", "KIND:1")
	variable nFuncs=itemsInList(functionsList)
	
	string functionsStr = "\t  <context id=\"functions\" style-ref=\"function\">\n"
	variable i
	for (i=0; i<(nFuncs); i+=1)
		functionsStr += "\t   <keyword>" + stringFromList(i, functionsList) + "</keyword>\n"
	endFor
	functionsStr += "\t  </context>\n"
	
	
	return functionsStr
end

function/S getKeywords() // Igor built-in operations
	string keywords
	keywords = "\t  <context id=\"keyword\" style-ref=\"keyword\">\n"
	string igorsKeywords = OperationList("*", ";", "internal")
	variable nKeywords = itemsInList(igorsKeywords)
	variable i
	for (i=0; i < nKeywords; i += 1)
		keywords += "\t   <keyword>" + stringFromList(i, igorsKeywords) + "</keyword>\n"
	endFor
	keywords += "\t  </context>\n"

	return keywords
end

function/S getCharacters()
	string characters
	characters = "\t  <context id=\"character\" style-ref=\"character\">\n"
	characters += "\t   <match>\\'(\\\[trnb\\\\\\'\\\"]|[^\\\])\\'</match>\n"
	characters +=  "\t  </context>\n"

	return characters
end

function/S getDecimals()
	string decimals
	decimals = "\t  <context id=\"decimal\" style-ref=\"decimal\">\n"
	decimals += "\t   <match>\b[0-9]+\b</match>\n"
	decimals += "\t  </context>"

	return decimals
end

function/S getStrings()
	string strings
	strings = "\t  <!--Strings-->\n"
	strings += "\t  <context id=\"string-double\" end-at-line-end=\"true\" style-ref=\"string\">\n"
	strings += "\t  <start>\"</start>\n"
	strings += "\t  <end>\"</end>\n"
	strings += "\t  <include>\n"
	strings += "\t	<context ref=\"def:line-continue\"/>\n"
	strings += "\t	<context ref=\"def:escape\"/>\n"
	strings += "\t  </include>\n"
	strings += "\t  </context>\n"
	
	return strings
end

function/S getComments()
	string comments
	comments = "\t  <!--comments-->\n"
	comments += "\t  <context id=\"line-comment\" style-ref=\"comment\">\n"
	comments += "\t  <start>//</start>\n"
	comments += "\t  <end>$</end>\n"
	comments += "\t  <include>\n"
	comments += "\t	<context ref=\"def:line-continue\"/>\n"
	comments += "\t	<context ref=\"def:in-comment\"/>\n"
	comments += "\t  </include>\n"
	comments += "\t  </context>\n"

	return comments
end

Function/S FlowControlList()
	String list = ""
	// flow control	
	list += "if;else;elseif;endif;for;endfor;"
	list += "strswitch;switch;case;endswitch;"
	list += "do;while;try;catch;endtry;break;continue;return;"
	return list
End

Function/S TypesList()
	String list = ""
	// data types
	list += "variable;string;constant;strconstant;"
	// reference types
	list += "NVAR;SVAR;WAVE;STRUCT;"
	// function/procedure/macro types
	list += "function;end;static;macro;window;graph;Structure;EndStructure;EndMacro;"
	list += "FuncFit;Proc;Picture;Menu;SubMenu;ThreadSafe;MultiThread;"
	// Commands
	list += "Prompt;DoPrompt;"
	return list
End

function/S makeLangSpecStr(languageID, languageName, languageVersion)
	string languageID, languageName, languageVersion
	
	string langSpecStr = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
	langSpecStr += getLicence()
	langSpecStr += "<language id=\"" + languageID + "\" _name=\"" + languageName + "\" version=\"" + languageVersion + "\" _section=\"Scientific\">\n"
	langSpecStr += getMetadata()
	langSpecStr += getStyles()
	langSpecStr += "\t<default-regex-options case-sensitive=\"false\"/>\n"
	langSpecStr += "\t<definitions>\n"
	langSpecStr += "\t <context id=\"" + languageID + "\">\n"
	langSpecStr += "\t  <include>\n"
	langSpecStr += getComments()
	langSpecStr += getStrings()
	langSpecStr += "\n"
	langSpecStr += getTypes()
	langSpecStr += "\n"
	langSpecStr += getFunctions()
	langSpecStr += "\n"
	langSpecStr += getCharacters()
	langSpecStr += "\n"
	langSpecStr += getKeywords()
	langSpecStr += "\n"
	langSpecStr += getDecimals()
	langSpecStr += "\t</include>\n"
	langSpecStr += "\t</context>\n"
	langSpecStr += "\t</definitions>\n"
	langSpecStr += "</language>\n"
	
	return langSpecStr
end

function createLanguageFile()

	string languageID = "gap"
	string languageName = "GAP"
	string languageVersion = "2.0"
	variable refNum

	// open file
	Open/M="Save Language File As...\n Please select all file types and \".lang\" extension" refNum as "gap.lang"
	if (strlen(S_fileName) < 1)		// User hit cancel button.
		return 0
	endif
	string fileNameStr = S_fileName
	
	string fileText = makeLangSpecStr(languageID, languageName, languageVersion)
	
	// write text to file
	Variable startPos = 0
	Variable posDelta = 300
	Variable n, length = strlen(fileText)
	For (n=0; n<length; n+=posDelta)
		fprintf refNum, "%s", fileText[startPos, startPos + posDelta]
		startPos += posDelta + 1
	EndFor
	
	
	// close file
	Close refNum
	return 0
end
